/*
 *	alsa-midi-io.h
 *
 */

#ifdef WITH_ALSA

#ifndef _ALSA_MIDI_IO_
#define _ALSA_MIDI_IO_

#include <alsa/asoundlib.h>

#include "midi-io.h"

class alsa_port_iterator
{
	public:
		virtual void 	next (snd_seq_client_info_t *, snd_seq_port_info_t *) = 0;
};

class alsa_port
:
public m_port
{
	public:
		void *	handle;
		int			client, port, q;
		bool		i_can_read, i_can_write;

										alsa_port();
									 ~alsa_port();

		virtual void		parse_input (m_tick, byte port, m_connector *);

		virtual bool		can_read() {return i_can_read;}
		virtual bool		can_write() {return i_can_write;}

		virtual int			get_read_fd();
		virtual int			get_write_fd();

		virtual bool		read (byte *) {return false;}
		virtual int			write_event (m_event * e, m_event_stamp * = 0);

		void						iterate (alsa_port_iterator *);
		bool						connect (char * name);
		bool						connect (int major, int minor);
};

#endif  /* _ALSA_MIDI_IO_ */

#endif  /* WITH_ALSA */
