/*
 *	arch-types.h
 *
 *	archetypes and architecture dependent type definitions
 *
 */

#ifndef _ARCH_TYPES_
#define _ARCH_TYPES_

#include <values.h>

#define TEN_TO_THE_SIXTH 1000000
#define TEN_TO_THE_NINTH 1000000000

/*
 * debug printf
 *
 */

#if defined (DEBUG) && defined (__GNUC__)

	#include <stdio.h>

	extern FILE * __debug_fp;

	#define _dbgprintf(x,args...) \
		if (x) \
		{ \
			if (x >= 2) \
				fprintf (__debug_fp, "%s:%d: ", __FILE__, __LINE__); \
			fprintf (__debug_fp, ## args); \
			fflush (__debug_fp); \
		}
#else
#define _dbgprintf(x...) ;
#endif

/*
 * machine specific
 *
 */

#ifdef __i386__
#ifdef DEBUG
	#define BREAKPOINT asm ("int $3;");
#else
	#define BREAKPOINT ;
#endif

typedef unsigned char		byte;
typedef unsigned short	word;
typedef unsigned int		dword;

typedef int m_tick;
#else
#error specify machine dependent types here.
#endif

#endif
