/*
 *	common-refcount.cc
 * 
 *	reference counting for cc objects;
 *
 *	and, btw, long live gcc.
 *	
 */

#include "arch-types.h"
#include "common-refcount.h"


#if defined (DEBUG) && defined (DBG_C_REFSUM)
int c_ref_obj::_c_refsum = 0;

void
c_ref_obj::print_refsum()
{
	fprintf (stderr, "\n_c_refsum = %d\n", _c_refsum);
}
#endif

c_ref_obj::c_ref_obj() 
{
	_c_refcount = 0; 
	_c_refname = "nil";
}

c_ref_obj::c_ref_obj (char * name) 
{
	_c_refcount = 0; 
	_c_refname = name;

	#if DBG_C_REF
	_dbgprintf (DBG_C_REF, "<new %s @ %x>\n", name, (int) this);
	#endif
}

void
c_ref_obj::set_ref_name (char * name)
{
	_c_refname = name;
}

c_ref_obj::~c_ref_obj()
{
	#if DBG_C_REF
	_dbgprintf (DBG_C_REF, "<del %s @ %x>\n", _c_refname, (int) this);
	#endif
}
