from midithing import *
from whrandom import random, randint

BassDrum = 'C3'
RimShot = 'C#3'
Toms = ('F3', 'g3', 'a3')
Tambourine = 'f#4'
Snare = 'E3'
HiHat = ('Gb3', 'Ab3', 'Bb3')
Ride = 'Eb4'
Bell = 'F4'
Crash = 'C#4'
Bells = ('G5', 'G#5')

def make_base (bpm = 72.8):
	song = Song()

	# tempo
	p = Part()
	song.add (p)
	p.add (Meta (Tempo, bpm = bpm))

	# rimshot
	p = Part()
	song.add (p)

	p.port = 3
	p.channel = 0

	p.add (Program (63))

	return song

def make_tempo_test (bars):
	bpm = 80
	song = make_base (bpm)
	song.add (Part())
	song.add (Part())
	song[1].port = 3
	song[1].add (Program (63))
	song[2].add ((Controller (0, 0), Program (1)))
	song[2].add (Note ('f#4', length = bars * song.division))

	for i in range (bars * 4):
		bpm += 2.0
		song[0].add (Meta (Tempo, bpm = bpm), i * song.division)
		song[1].add (Note (RimShot, length = 2), i * song.division)
	
	song[1].add (Note (BassDrum), bars * 4	+ 3 * song.division)
	song[1].add (Note (BassDrum), bars * 4 + 7 * song.division / 4)
	return song

def make_apache():
	song = make_base()

	offset = 0
	bars = 448

	p = Part()
	song.add (p)

	p.port = 0
	p.add (Controller (0, 0))
	p.add (Program (105))

	p.add (Controller (0, 0, channel = 1))
	p.add (Program (105, channel = 1))

	p.add (Controller (0, 1, channel = 2))
	p.add (Program (90, channel = 2))

	tick = 0
	length = bars * 4 * song.division

	p.add (Note ('b3', velocity = 68, channel = 0, tick = tick, length = length))
	p.add (Note ('e4', velocity = 78, channel = 1, tick = tick + song.division / 4, length = length))

	p.add (Note ('b4', channel = 2, tick = tick + 2 * song.division, length = length))

	return song


def make_groove (bars = 448):
	song = make_base()

	offset = song.division * 4

	p = song[1]

	for i in range (0, bars * 4, 1):
		tick = i * song.division + offset
		p.add (Note ('C#3', velocity = 77 + randint (0, 10), tick = tick))
		
		if (i % 4 == 0):
			if (i != 4):
				p.add (Note ('f4', velocity = 57 + randint (0, 10), tick = tick))
			p.add (Note ('c3', velocity = 67, tick = tick + song.division / 2))
			p.add (Note ('c3', velocity = 57, tick = tick - song.division / 4))

	for i in range (1, bars * 4, 2):
		tick = i * song.division + offset 
		p.add (Note ('G#3', velocity = randint (60, 63), tick = tick))

	for i in range (0, bars * 16, 1):
		tick = i * song.division / 4 + offset 
		if (i % 4 == 2):
			continue
		if (i % 4 == 0):
			velocity = randint (40, 50)
		else:
			velocity = randint (50, 60)
		p.add (Note ('D#4', velocity = velocity, tick = tick, length = song.division / 4 - 1))
	
	for e in p:
		try:		e.length = 12
		except:	pass

	return song

def make_new():
	song = make_base()
	p = song[1]
	bars = 8
	quarter = song.division
	
	for tick in range (0, bars * 4 * quarter, quarter):
		p.add (Note (RimShot, tick = tick))
	
	p.add (Note (RimShot, tick = 3 * song.division + 176))

	return song
