/*
 *	midi-ascii-port.cc
 *
 *	a port that only passes ascii meta events, to drive programs like
 *	csound.
 */

#include <sys/types.h>
#include <sys/socket.h>
#include <unistd.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>

#include <stdexcept>

#include "midi-io.h"

/*	
 *	m_port
 *
 */

m_ascii_port::m_ascii_port (int _fd, bool __own_fd) 
: 
m_port ("m_ascii_port") 
{
	fd = _fd;
	_own_fd = __own_fd;
}

m_ascii_port::~m_ascii_port() 
{
	if (_own_fd)
		close (fd);
}

bool
m_ascii_port::event_in (m_event * e, m_event_stamp * stamp)
{
	if (!e->is_meta (M_META_TEXT))
		return 0;
	
	c_char_buffer * buffer = e->get_data_buffer();
	write (fd, buffer->items, buffer->count);

	return true;
}


