/*
 *	midi-io.h
 *
 *	yet another midi port interface
 *
 */

#ifndef _MIDI_IO_
#define _MIDI_IO_

#include <sys/poll.h>
#include <unistd.h>
#include <fcntl.h>

#include "arch-threads.h"
#include "midi-event.h"
#include "midi-part.h"
#include "midi-file.h"
#include "midi-song.h"
#include "midi-sync.h"

/*	
 *	m_io
 *	
 *	output dispatcher, thread polling input fd's.
 */

class m_clock;

class m_io
:
public a_thread,
public m_connector
{
	public:
		m_tick					tick;
		m_clock *				clock;
		m_connector *		out;
		m_sync					sync;

		c_ref_list			ports;
		m_connector *		port (int i) {return (m_connector *) ports[i];}
		
										m_io (m_connector *);
									 ~m_io();

		/* m_connector:: */
		virtual void		set_tick (m_tick);
		virtual bool		event_in (m_event * e, m_event_stamp * = 0);
		virtual void		advance (double dt, m_connector * out);
	
		void						clear();
		int							add_port (m_connector * _port);
		bool						remove_port (m_connector * _port);
		bool						replace_port (int i, m_connector * _port);

		void						set_output (m_connector * _out);

	private:
		a_mutex	mutex;
		struct {
			int					fd[2];
		} notification;
		
		enum {
			Quit					= 0,
			PortAdded			= 1,
			PortRemoved		= 2,
			PortReplaced	= 3
		};
		
		virtual void *		thread();
};

#endif  /* _MIDI_IO_ */
