/*
 *	midi-state.cc
 *
 */
 
#include <string.h>

#include "midi-io.h"

m_state::m_state()
: 
m_connector ("m_state") 
{
	reset();
}

void
m_state::reset()
{
	memset (pitch, 0, sizeof pitch);
	memset (note, 0, sizeof note);
	memset (ctrl, 0xff, sizeof ctrl);
	memset (pres, 0xff, sizeof pres);
}

bool
m_state::event_in (m_event * e, m_event_stamp * stamp)
{
	int channel = (stamp && stamp->channel >= 0) ? stamp->channel : e->get_channel();

	switch (e->get_type())
	{
		case M_NOTE_ON:
			note[channel][e->get_note()]++;
			return true;
			
		case M_NOTE_OFF:
			if (note[channel][e->get_note()])
				note[channel][e->get_note()]--;
			return true;
			
		case M_CONTROL_CHANGE:
			ctrl[channel][e->get_param_0()] = e->get_param_1();
			return true;
		
		/* virus' second page of control changes */
		case M_NOTE_TOUCH:
			pres[channel][e->get_note()] = e->get_velocity_on();
			return true;

		case M_PITCH_WHEEL:
			pitch[channel] = e->get_pitch();
			return true;
	}

	return false;
}


