/*
 *	midi-sync.h
 *
 */

#ifndef _MIDI_SYNC_
#define _MIDI_SYNC_

#include "midi-song.h"

class m_song;

/*
 *	the m_sync object has a list of songs and is driven by an m_io 
 *	object that relays clock pulses and incoming MIDI messages.
 *
 */

class m_sync
:
public m_connector
{
	public:
		c_ref_list		songs;
		m_song *			song (int i) {return (m_song *) songs[i];}
		int						add_song (m_song *);
		bool					remove_song (m_song *);
	
	public:
		bool					locked,
									use;

		struct {
			double	current;
			double	per_frame;
			double	per_tick;
		} time;
		
		struct {
			m_tick	current;
		} tick;

		m_tick division;

	public:
									m_sync();
								 ~m_sync();

		/* m_connector::* */
		m_connector *	through;
		void					set_through (m_connector *);

		virtual bool	event_in (m_event *, m_event_stamp * = 0);
		virtual void	advance (double dt, m_connector * out);
		
		void					advance_to (double t);

	private:
		struct {
			byte	hour, minute, second, frame, quarter;
			byte	mask;
		} mtc;

		/* mtc & sysex start/stop etc */
		bool					do_sysex (m_event *);
		void					do_quarter_frame (m_event *);

		/* clock etc */
		void					do_song_pos (m_event *);
		void					do_clock();
		void					do_start();
		void					do_continue();
		void					do_stop();
};

#endif
