/*
 *	midi-xy-mapper.h
 *
 *	map events to xy coordinates.
 *
 */

#ifndef _MIDI_XY_MAPPER_
#define _MIDI_XY_MAPPER_

#include "midi-song.h"
#include "common-rgb-classes.h"

/*
 *	maps ticks/times to x coordinates
 *
 */

class m_x_mapper
{
	public:
		m_song *		song;
		int					x0;
		int					magnification;
		double			pixels_per_tick;
		double			ticks_per_pixel;

								m_x_mapper (m_song *);
							 ~m_x_mapper();
						
		void				set_magnification (int _magnification, int x);
		void				scroll (int dx);

		m_tick			x2tick (int);
		int					tick2x (m_tick);
		
		/* not yet. */
		double			x2time (int);
		int					time2x (double);
};

/*
 *	maps note heights to y coordinates
 *
 */

class m_y_mapper
{
	public:
		int					y0;
		int					magnification;
		double			pixels_per_note;
		double			notes_per_pixel;
		
		bool				is_staff [128];

		int					n2y [128];
		c_list<int>	y2n;
		int					alpha [128];
		int					gravity [128];
		
								m_y_mapper();
							 ~m_y_mapper();
						
		void				set_magnification (int _magnification, int y);
		void				set_position (int y, int note);
		void				scroll (int dy);

		void				init();

		int					note_height();

		int					y2note (int);
		int					note2y (int);
};

#endif
