'pixmaps and buttons.'

from gtk import *

class DotButton (GtkButton):
	def __init__ (self, window):
		GtkButton.__init__ (self)
		self.add (Dot (window, (15, 153, 38)))
		
		
class SmallDot (GtkPixmap):
	'draws a 12x12 dot in the color you specify'
	def __init__ (self, window, color):
		xpm_d = [
			"8 8 3 1", 
			".	c None", 
			"x	c #000000",
			"y	c %s" % color
		]	
		quarter = [
			"....",
			"yy..",
			"yyy.",
			"yyy.",
		]
		
		for line in quarter:
			for char in line:
				line = char + line
			xpm_d += [line]
		
		quarter.reverse()

		for line in quarter:
			for char in line:
				line = char + line
			xpm_d += [line]

		pixmap, mask = create_pixmap_from_xpm_d (window, None, xpm_d)
		GtkPixmap.__init__ (self, pixmap, mask)


class Dot (GtkPixmap):
	'draws a 12x12 dot in the color you specify'
	def __init__ (self, window, color):
		xpm_d = [
			"12 12 3 1", 
			".	c None", 
			"x	c #000000",
			"y	c %s" % color
		]	
		quarter = [
			"yy....",
			"yyyy..",
			"yyyyy.",
			"yyyyy.",
			"yyyyyy",
			"yyyyyy"
		]
		
		for line in quarter:
			for char in line:
				line = char + line
			xpm_d += [line]
		
		quarter.reverse()

		for line in quarter:
			for char in line:
				line = char + line
			xpm_d += [line]

		pixmap, mask = create_pixmap_from_xpm_d (window, None, xpm_d)
		GtkPixmap.__init__ (self, pixmap, mask)


class PlaySymbol (GtkPixmap):
	'draws a play symbol'
	def __init__ (self, window, color):
		xpm_d = [
			"12 12 3 1", 
			".	c None", 
			"x	c #000000",
			"y	c #%02x%02x%02x" % color
		]
		lines = [
			".................",
			".xx..............",
			".xyxx............",
			".xyyyxx..........",
			".xyyyyyxx........",
			".xyyyyyyyxx......",
			".xyyyyyyyyyxx....",
			".xyyyyyyyyyyyxx..",
			".xyyyyyyyyyyyyyxx"
		]	
		
		for line in lines:
			xpm_d += [line]
		
		lines.reverse()

		for line in quarter:
			xpm_d += [line]

		pixmap, mask = create_pixmap_from_xpm_d (window, None, xpm_d)
		GtkPixmap.__init__ (self, pixmap, mask)

class XPM (GtkPixmap):
	'loads an xpm file'
	def __init__ (self, window, name):
		(pixmap, mask) = create_pixmap_from_xpm (window, None, "pixmaps/%s.xpm" % name)
		GtkPixmap.__init__ (self, pixmap, mask)

class ColoredPixmap (GtkPixmap):
	def __init__ (self, window, color, width, height):
		xpm_d = [
					"%d %d 1 1" % (width, height), 
					".	c #%02x%02x%02x" % (color[0], color[1], color[2])]
		for line in range (height):
			xpm_d += [width * "."]
		
		pixmap, mask = create_pixmap_from_xpm_d (window, None, xpm_d)
		GtkPixmap.__init__ (self, pixmap, mask)
